#lang racket/base

(require
 "1-lc-syntax.rkt"
 "2-anf-and-monadic-form.rkt"
 (except-in "3-machine-semantics.rkt" insert deref)
 (except-in "4-ab-normal-form.rkt" insert deref)
 "5-compiler.rkt"
 redex/reduction-semantics
 redex/gui)

(provide
 apply-reduction-relation
 apply-reduction-relation*
 redex-match?
 redex-match
 term
 traces
 hole

 lcL
 eval-lcL
 (rename-out
  [lcL lambdaL]
  [eval-lcL eval-lambdaL])
 δ

 intro-example
 running-example
 nested-branches
 (rename-out
  [nested-branches nested-branches-example])
 fact-example

 lCKL
 (rename-out
  [lCKL lambda-ckL])
 lck->
 (rename-out
  [lck-> lambda-ck->])
 init-ck

 a->
 a->*
 a-normalize
 ANFL
 meval-lcL
 (rename-out
  [meval-lcL monadic-eval-lambdaL])
 b->
 b->*
 b-normalize
 monadicL

 anfck->
 (rename-out
  [anfck-> anf-ck->])
 ck-max-stack

 regionL
 regionCSKL
 regioncsk->
 (rename-out
  [regioncsk-> region-csk->])
 init-csk
 csk-read-val
 csk-max-memory
 csk-max-regions

 reg1-term

 aregionL
 ra->
 ra->*
 anf-reg1-term

 bregionL
 rb->
 rb->*
 bnf-reg1-term

 imonadicL
 abnfL
 ab->
 ab->*
 ab-normalize
 cek-imonadicL
 (rename-out
  [cek-imonadicL imonadic-cekL])
 init-cek
 cek->
 cek-max-stack

 rimonadicL
 cesk->
 init-cesk
 rab->
 rab->*
 rab-normalize
 flatten-begin
 cesk-max-memory
 cesk-max-stack
 cesk-max-regions
 cesk-read-val

 anf
 monadic
 monadic-code-gen
 anf-code-gen
 abnf

 abnormal-compile
 anf-compile
 inc-var
 )
